/*
 * Welcome to Sol's Source-O-Kludges!
 *
 * This is my entry for the flipcode 'bugs' coding contest. Written in 
 * 3 evenings while working 10 hours a day. 
 *
 * v3 adds one evening's work though.
 *
 * A mess. Really. Consider yourself warned.
 *
 * I never meant this source to be anything really nice, so bear with me.
 *
 * Feel free to use this source in any way you can imagine etc, as long as
 * it does no damage to me.
 */
#include <windows.h>
#include <stdlib.h>
#include "SDL.h"        // Yup, SDL required.
#include "pcxload.h"    // ..and my ages-old pcx loader too. again.

#define INITIAL_FOODPILE 40
#define MAP_FOOD 1      // map ID for food
#define MAP_HOME 2      // map ID for home
#define MAP_WALL -1     // map ID for wall (and map ID for ground is 0, naturally)
#define ANTS 128        // Number of ants
#define ITERS 32        // and number of iterations in turbo-boost mode
#define FOOD_COLOR (short)0xffff    // color of ant with food
#define ANT_COLOR (short)(0x1f<<11) // color of ant.

extern "C" unsigned long genrand(); // Mersenne Twister (c)97-99 M. Matsumoto and T. Nishimura

extern "C" void sgenrand(unsigned long seed);

int boost = 0;          // keyboard: boost mode   
int smell_o_vision = 0; // keyboard: smell-o-vision mode

SDL_Surface *screen;    // screen surface
short * skin;           // and a cute skin
short * sprites;        // aand the sprites.

int food_taken_home = 0; // counter for food brought home

// whee! it's a class! 
// data for each map cell 
class map_cell  
{
public:
    int cell_type;      // MAP_ .. defs above, or 0 for ground
    int smell_of_home;  // current home scent level
    int smell_of_food;  // current food scent level
    int food_amt;       // food amount at this spot
    map_cell() { smell_of_home = smell_of_food = 0; cell_type = 0; food_amt = 0;}
};

map_cell map[320*240];  // map cells.
int home_cells;         // Number of home cells in the map (needed for ant reset, below)
int * home_cell_ofs;    // offsets to home cells in the map (needed for ant reset, below)


// Ant definition and implementation in one.
class ant_def
{
public:
    int last_dir;   // last direction walked
    int pos_x;      // current x ofs
    int pos_y;      // and y ofs
    int has_food;   // are we carrying food?
    int smell_of_home;  // current scent of home
    int smell_of_food;  // current scent of food.
    int life;       // this is your life and it's ending one frame at a time.
    
    // Reset function. Called when ant dies or is generated in the beginning.
    void reset()
    {
        has_food = 0;   // bad ant! no food!
        last_dir=genrand()%8;   // random start direction
        int pos = home_cell_ofs[genrand()%home_cells];  // and random spot at home
        pos_x = pos % 320;  
        pos_y = pos / 320;
        life = 1024;    // let's live 1k iterations..
        smell_of_food = 0;  // and squeaky-clean too!
        smell_of_home = 0;
    }

    // Moving function. This is the most horribliest pile of hacks here.
    // Also contains the most interesting bits of code too, I guess.
    void move() 
    {        
        if (smell_of_food) smell_of_food -= 10; // scents fade in time
        if (smell_of_home) smell_of_home -= 10;
        if (life) life --; // and so does life
        else reset(); // out of life? reset.
        int dir_preferability[8]; 
        int current_ofs = pos_y * 320 + pos_x;
        // Depending on whether we have food or not, we prefer going 
        // to one direction or another.
        if (has_food)
        {
            dir_preferability[0] = map[current_ofs-1  ].smell_of_home;
            dir_preferability[1] = map[current_ofs-321].smell_of_home;
            dir_preferability[2] = map[current_ofs-320].smell_of_home;
            dir_preferability[3] = map[current_ofs-319].smell_of_home;
            dir_preferability[4] = map[current_ofs+1  ].smell_of_home;
            dir_preferability[5] = map[current_ofs+321].smell_of_home;
            dir_preferability[6] = map[current_ofs+320].smell_of_home;
            dir_preferability[7] = map[current_ofs+319].smell_of_home;
        } 
        else
        {
            dir_preferability[0] = map[current_ofs-1  ].smell_of_food;
            dir_preferability[1] = map[current_ofs-321].smell_of_food;
            dir_preferability[2] = map[current_ofs-320].smell_of_food;
            dir_preferability[3] = map[current_ofs-319].smell_of_food;
            dir_preferability[4] = map[current_ofs+1  ].smell_of_food;
            dir_preferability[5] = map[current_ofs+321].smell_of_food;
            dir_preferability[6] = map[current_ofs+320].smell_of_food;
            dir_preferability[7] = map[current_ofs+319].smell_of_food;
        }        

        // walls don't have any scent, so they're 0 to begin with. Here we
        // add 1 to all non-wall directions.
        if (map[current_ofs-1  ].cell_type!=MAP_WALL) dir_preferability[0]+=1;
        if (map[current_ofs-321].cell_type!=MAP_WALL) dir_preferability[1]+=1;
        if (map[current_ofs-320].cell_type!=MAP_WALL) dir_preferability[2]+=1;
        if (map[current_ofs-319].cell_type!=MAP_WALL) dir_preferability[3]+=1;
        if (map[current_ofs+1  ].cell_type!=MAP_WALL) dir_preferability[4]+=1;
        if (map[current_ofs+321].cell_type!=MAP_WALL) dir_preferability[5]+=1;
        if (map[current_ofs+320].cell_type!=MAP_WALL) dir_preferability[6]+=1;
        if (map[current_ofs+319].cell_type!=MAP_WALL) dir_preferability[7]+=1;
        
        // The ants really don't want to turn around. They don't like doing sharp
        // turns either. So, the preferability of these movements is divided by 2,4 and 16 here.
        
        dir_preferability[(last_dir+2)&7] >>= 1;
        dir_preferability[(last_dir+3)&7] >>= 2;
        dir_preferability[(last_dir+4)&7] >>= 4;
        dir_preferability[(last_dir+5)&7] >>= 2;
        dir_preferability[(last_dir+6)&7] >>= 1;
        
        // Calculate total propability..
        int total_prop = 0;
        int i;      
        for (i = 0; i < 8; i++)
        {
            dir_preferability[i] *= dir_preferability[i]; // tilt the slope higher
            total_prop += dir_preferability[i];
        }
        
        // m-kay. now then, we have two methods of figuring out where to go next:
        // totally deterministic (always select the one which is most deterministic) and
        // montecarlo, where we take a random and see which preferability hits the
        // jackpot (the more preferable the direction, the more likely it is to score)
        int movedir, deterministic, montecarlo;

        if (total_prop == 0)
        {
            // dead end case (no preferable directions)
            movedir = (abs(genrand())%8);
        } 
        else
        {
            
            int r = abs(genrand())%total_prop; // roll the dice..            
            i = 0;
            // check which direction we point..
            while (r >= 0)
            {
                r -= dir_preferability[i];
                i ++;
            }
            montecarlo = i - 1; // and we have a winner.

            int max = 0;
            if (total_prop < 8) // if deteministic doesn't make any sense (all directions are the same), use montecarlo.
                deterministic = montecarlo;
            else
            {
                // find the max case.
                int maxv = 0;
                for (i = 0; i < 8; i++)
                {
                    if (max < dir_preferability[i])
                    {
                        max = dir_preferability[i];
                        maxv = i;
                    }
                }
                deterministic = maxv;
            }
            /* 
             * // old method:
             *  // now, in a perfect world montecarlo would be enough.
             *  // However, it's not, so we use it only once in 8 times.
             *  // If you set the value (8 here) lower, the ants will act
             *  // more randomly, and rise it up and they'll follow the
             *  // trails as if there wasn't any other way.
             *   movedir = genrand()%8 ? deterministic : montecarlo;
             */
            // new method:
            // max preferability is 16384. Find the closest power-of-two to max...
            // theretical max is 15
            int pow = 1;
            while (max>>pow) pow++;
            pow = (pow/4)+1;
            // make the ants act more deterministically if scents are strong in general
            movedir = (genrand())%(pow) ? deterministic : montecarlo;
        }

        movedir = (movedir) % 8;
            
        // Next we'll do the matching ants fractal bit, or whatever is left of it:
        
        int new_x=pos_x,new_y=pos_y;
        switch (movedir)
        {
        case 0:
            new_x--;
            break;
        case 1:
            new_x--;
            new_y--;
            break;
        case 2:
            new_y--;
            break;
        case 3:
            new_y--;
            new_x++;
            break;
        case 4:
            new_x++;
            break;
        case 5:
            new_x++;
            new_y++;
            break;
        case 6:
            new_y++;
            break;
        case 7:
            new_y++;
            new_x--;
            break;
        default: return;
        }
        // set new move dir at this point so the ant has some way of turning around..
        last_dir = movedir;
        // ..if it hits the wall here:
        if (new_x < 1 || new_y < 1 || new_x >= 319 || new_y >= 239) return;
        // yay, we have a new location:
        int new_ofs = new_y * 320 + new_x;
        // which might be inside a wall (oops)
        if (map[new_ofs].cell_type == MAP_WALL) return;
        // or it might be home, and if it is
        if (map[new_ofs].cell_type == MAP_HOME)
        {
            // we check if we happened to have some food
            if (has_food) 
            {
                // yay! food taken home.
                has_food = 0; // I'll take that, thank you.
                food_taken_home ++; // some statistics..
                life = 1024; // new grant of lifespan. good ant. go and fetch some more now.
            }
            // whether we have food or not, home still stinks:
            smell_of_home = 16384; 
            smell_of_food = 0; // take a shower.
        }
        // it might also be that we've landed on food.
        if (map[new_ofs].food_amt > 0)
        {
            if (!has_food) 
            {
                // and since we're not carrying any, let's pick it up.
                map[new_ofs].food_amt--;
                if (map[new_ofs].food_amt == 0)
                {
                    skin[new_x*2+(new_y*640*2+1)]=0;
                    skin[new_x*2+(new_y*640*2+640)]=0;
                }
                has_food = 1;
                life += 1024; // and with the new-found energy we might survive back home, too.
            }
            // wake up and smell the food..
            smell_of_food = 16384;
            smell_of_home = 0; // just in case.
        } 
        else
        {
            // non-food carrying ants disturb the scent
            if (!has_food && map[new_ofs].smell_of_food > 0)
                map[new_ofs].smell_of_food --;
        }

        // let's paint scent on the landscape.
        if (smell_of_food > map[new_ofs].smell_of_food)
            map[new_ofs].smell_of_food = smell_of_food;
        if (smell_of_home > map[new_ofs].smell_of_home)
            map[new_ofs].smell_of_home = smell_of_home;
        // If we made it this far, I guess the location is ok.
        pos_x = new_x;
        pos_y = new_y;        
    }

    // Drawing function. 
    void draw(short * framebuffer, int pitch)
    {
        int ofs = pos_x * 2 + pos_y * 2 * pitch - pitch - 1;
        int spriteofs = (has_food?4*4*8:0) + last_dir*4*4;
        for (int y = 0; y < 4; y++,ofs+=pitch-4)
            for (int x = 0; x < 4; x++,ofs++,spriteofs++)
                framebuffer[ofs] = sprites[spriteofs];
    }
};

ant_def ant[ANTS]; // array of ants. gee.

// init func.. more ugly hacks and stupid code follows.
void init()
{
    char * pic = loadpcx("ants_skin.pcx");
    char * pal = loadpcxpal("ants_skin.pcx");
    skin = new short[640*480]; // pcx is 8bit paletted, but we want 16bit hicolor.
    // Let's do some slo-mo conversion then.
    for (int i = 0; i < 640 * 480; i++)
        skin[i]=(((pal[(pic[i]&0xff)*3+2]&0xff)>>3)<<0)+
                (((pal[(pic[i]&0xff)*3+1]&0xff)>>3)<<6)+
                (((pal[(pic[i]&0xff)*3+0]&0xff)>>3)<<11);    
    free(pic); // We don't need all this temporary garbage anymore, so 
    free(pal); // let's free it. (loadpcx uses malloc, thus, free).

    // Next up: load sprites.

    pic = loadpcx("ants_sprites.pcx");
    pal = loadpcxpal("ants_sprites.pcx");

    sprites = new short[4*4*2*16];
    for (i = 0; i < 4*4*2*16; i++)
    {
        sprites[i] = (((pal[(pic[i]&0xff)*3+2]&0xff)>>3)<<0)+
                     (((pal[(pic[i]&0xff)*3+1]&0xff)>>3)<<6)+
                     (((pal[(pic[i]&0xff)*3+0]&0xff)>>3)<<11);    
    }
    free(pic);
    free(pal);

    // Next we'll be analyzing the base map for stuff.

    home_cells = 0; // like where home is.

    pic = loadpcx("ants_base.pcx"); // load it up..
    for (i = 0; i < 320*240; i++) // for a while the base map was 640x480, but that was 
    {                                 // just too slow.. so I changed the resolution 
        int j = (i%320)*2 + (i/320)*640*2;  // to 320x240 without bothering to think about it.
        if ((pic[j]&0xff) == 254)     // yess.. hardcoded color numbers.
        {
            map[i].cell_type=MAP_FOOD;  
            map[i].food_amt = INITIAL_FOODPILE;
            map[i].smell_of_food=16384;
        }
        if ((pic[j]&0xff) == 253)
            map[i].cell_type=MAP_WALL;
        if ((pic[j]&0xff) == 252)
        {
            map[i].cell_type=MAP_HOME;
            map[i].smell_of_home=16384;
            home_cells++; // count home cells for later..
        }
    }
    home_cell_ofs = new int[home_cells]; // ie. here.
    home_cells = 0; // and let's count again!
    for (i = 0; i < 320*240; i++)
    {
        int j = (i%320)*2 + (i/320)*640*2; // don't you just *love* copy-paste coding?
        if ((pic[j]&0xff) == 252) 
        {
            home_cell_ofs[home_cells]=i;
            home_cells++;
        }
    }
    free(pic); // remember to free the base map, as map cells have been populated..
    
    // And finally breath some initial life to our ants..

    for (i = 0; i < ANTS; i++)
    {
        ant[i].reset(); // can't be called in constructor because it needs home_cells..                       
        ant[i].life = (i*7131) % 2048; // hack to avoid a second burst later on
    }
}

// rendering function.. framerate? what's that? 
void reindeer()
{    
    if ( SDL_LockSurface(screen) < 0 ) 
        return;

    int i,j,yofs,ofs,c,d; // hum de dum.

    if (smell_o_vision) 
    {
        // another map resolution change quick hack pile..
        for (i=0,yofs=0,c=0,d=0;i<480;i++,yofs+=screen->pitch/2)
            for (j=0,ofs=yofs;j<640;j++,ofs++,d++)
            {
                if ((i&1 * j&1)) c++;                             
                if (j<512 && (i&1 * j&1))
                    ((short*)screen->pixels)[ofs] = (int)(map[c].smell_of_home / 512) | ((int)(map[c].smell_of_food / 512)<<11);
                else
                ((short*)screen->pixels)[ofs]=skin[d];
            }
    }
    else
    {
        for (i=0,yofs=0,d=0;i<480;i++,yofs+=screen->pitch/2)
            for (j=0,ofs=yofs;j<640;j++,ofs++,d++)
                ((short*)screen->pixels)[ofs]=skin[d];
    }

    // this is really ridiculous, I know.

    for (i = 0; i < ANTS; i++)
        ant[i].draw((short*)screen->pixels,screen->pitch/2);

    // food-taken-home-o-meter:

    d = food_taken_home;
    for (i = 0; i < 100 && d > 0; i++)
        for (j = 0; j < 100; j++, d--)
            if (d>0)
                ((short*)screen->pixels)[(465 - i) * screen->pitch / 2 + (525 + j)] = FOOD_COLOR;

    // and ant state indicator.

    for (i = 0, d = 0; i < 4; i++)
        for (j = 0; j < 32; j++, d++)
            ((short*)screen->pixels)[(332 + i*2) * screen->pitch / 2 + (540 + j*2)] = ant[d].has_food ? FOOD_COLOR : ANT_COLOR;

            
    if ( SDL_MUSTLOCK(screen) ) 
        SDL_UnlockSurface(screen);

    // do the simuation iteration loop-thingy. boost is either 0 or 1.

    for (int iters = 0; iters < (boost*ITERS +1); iters++)
    {
        // move them ants
        for (i = 0; i < ANTS; i++)
            ant[i].move(); 
        // and make map scent fade.        
        for (i = 0; i < 320*240; i++)
            {
                if (map[i].food_amt == 0       && map[i].smell_of_food > 0) map[i].smell_of_food -= 3;
                if (map[i].cell_type!=MAP_HOME && map[i].smell_of_home > 0) map[i].smell_of_home -= 2;
            }                    
          
    }

    // *dump*

    SDL_UpdateRect(screen, 0, 0, 640, 480);    
}

// This is fairly directly from SDL examples and shouldn't contain any horrible hacks.
int main(int argc, char *argv[])
{
    sgenrand(GetTickCount()); // initialize random generator

    if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
        fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
        exit(1);
    }

    atexit(SDL_Quit);
    
    screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE);
    if ( screen == NULL ) {
        fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
        exit(1);
    }

    init();

    while (1)
    {
        reindeer();

        SDL_Event event;
        while ( SDL_PollEvent(&event) ) 
        {
            switch (event.type) 
            {
            case SDL_KEYDOWN:

                if (event.key.keysym.sym == SDLK_RSHIFT || 
                    event.key.keysym.sym == SDLK_LSHIFT)
                    boost = 1;
                if (event.key.keysym.sym == 's')
                    smell_o_vision = 1;
                break;
            case SDL_KEYUP:
                if (event.key.keysym.sym == SDLK_ESCAPE)
                    return 0;
                if (event.key.keysym.sym == SDLK_RSHIFT || 
                    event.key.keysym.sym == SDLK_LSHIFT &&
                    !(event.key.keysym.mod & KMOD_RSHIFT ||
                      event.key.keysym.mod & KMOD_LSHIFT))
                    boost = 0;
                if (event.key.keysym.sym == 's')
                    smell_o_vision = 0;
                break;
            case SDL_QUIT:
                return(0);
            }
        }
    }
    return 0;
}

